-- plugin to provide info on Delving Malices

importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."
pluginName=plugin:GetName();
-- to do
-- EVERYTHING!!!!!!

-- foreign language support, need french and german translations of String.lua

import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()

MinWidth=740
MinHeight=215

if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

mainVisible=true;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state
language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

-- load saved settings
Settings=PatchDataLoad(Turbine.DataScope.Character, pluginName.."Settings")
if Settings==nil then Settings={} end

-- load the settings and set the window position if possible, otherwise default to center
local initHeight=600;
local initWidth=800;
if initWidth>displayWidth then initWidth=displayWidth end
if initHeight>displayHeight then initHeight=displayHeight end
local initLeft=(displayWidth - initWidth) / 2;
local initTop=(displayHeight - initHeight) / 2;

if Settings.DisplayWidth==nil or Settings.DisplayHeight==nil then
	-- no settings, go with init
elseif Settings.DisplayWidth~=displayWidth or Settings.DisplayHeight~=displayHeight then
	-- resolution has changed, use percents to determine new position/size (drift will be irrelovent compared to resolution change)
	Settings.MainTop=math.floor(euroNormalize(Settings.MainTopPercent)*displayHeight+.5)
	Settings.MainLeft=math.floor(euroNormalize(Settings.MainLeftPercent)*displayWidth+.5)
	Settings.MainHeight=math.floor(euroNormalize(Settings.MainHeightPercent)*displayHeight+.5)
	Settings.MainWidth=math.floor(euroNormalize(Settings.MainWidthPercent)*displayHeight+.5)
else
	-- settings valid and resolution did not change so use setting instead of percent to avoid rounding errors causing drift
	initTop=Settings.MainTop
	initLeft=Settings.MainLeft
	initWidth=Settings.MainWidth
	initHeight=Settings.MainHeight
end
if Settings.Opacity==nil then
	Settings.Opacity=1
else
	Settings.Opacity=euroNormalize(Settings.Opacity)
end
if Settings.TrimColor==nil then
	Settings.TrimColor=Turbine.UI.Color(.2,.5,.9)
else
	Settings.TrimColor=Turbine.UI.Color(euroNormalize(Settings.TrimColor.A),euroNormalize(Settings.TrimColor.R),euroNormalize(Settings.TrimColor.G),euroNormalize(Settings.TrimColor.B))
end
if Settings.FontColor==nil then
	Settings.FontColor=Turbine.UI.Color(1,.9,.5)
else
	Settings.FontColor=Turbine.UI.Color(euroNormalize(Settings.FontColor.A),euroNormalize(Settings.FontColor.R),euroNormalize(Settings.FontColor.G),euroNormalize(Settings.FontColor.B))
end
if Settings.BackColor==nil then
	Settings.BackColor=Turbine.UI.Color(.05,.05,.05);
else
	Settings.BackColor=Turbine.UI.Color(euroNormalize(Settings.BackColor.A),euroNormalize(Settings.BackColor.R),euroNormalize(Settings.BackColor.G),euroNormalize(Settings.BackColor.B))
end
if Settings.HeadingsColor==nil then
	Settings.HeadingsColor=Turbine.UI.Color(1,1,1);
else
	Settings.HeadingsColor=Turbine.UI.Color(euroNormalize(Settings.HeadingsColor.A),euroNormalize(Settings.HeadingsColor.R),euroNormalize(Settings.HeadingsColor.G),euroNormalize(Settings.HeadingsColor.B))
end
if Settings.ListTextColor==nil then
	Settings.ListTextColor=Turbine.UI.Color(1,1,1);
else
	Settings.ListTextColor=Turbine.UI.Color(euroNormalize(Settings.ListTextColor.A),euroNormalize(Settings.ListTextColor.R),euroNormalize(Settings.ListTextColor.G),euroNormalize(Settings.ListTextColor.B))
end
if Settings.Font==nil then
	Settings.Font=Turbine.UI.Lotro.Font.Verdana20;
end
if Settings.Language==nil then
	Settings.Language=-1
else
	if Settings.Language>0 then
		language=Settings.Language
	end
end
if Settings.DataVersion==nil then
	Settings.DataVersion=plugin:GetVersion()
end
if Settings.LoadMinimized==nil then
	Settings.LoadMinimized=false
end
if Settings.ShowIconWhenMinimized==nil then
	Settings.ShowIconWhenMinimized=true
end
if Settings.UseMiniIcon==nil then
	Settings.UseMiniIcon=false
end
if Settings.MiniIconOpaque==nil then
	Settings.MiniIconOpaque=true
end
-- now import
import (importPath.."DropDownList");
import (importPath.."RadioButtonGroup");
import (importPath.."FontSupport")
import (importPath.."DebugWindow");
import (importPath.."OptionsWindow");
import (importPath.."MaliceData")
fontMetric=FontMetric()

-- determine the current variant
baseMaliceDate=1713337200 --1713326401 -- known datetime for variant 1, 2024/04/17 03:00:00 (1713326400-10799) adjusted for 3AM offset(time zone UTC+5 which is why it is 18000 seconds higher)
_,todayVariant=math.modf(math.floor((Turbine.Engine:GetLocalTime()-baseMaliceDate)/86400)/6)
todayVariant=math.floor(todayVariant*6+.5)+1

-- account for changed resolution
if initWidth>displayWidth then initWidth=displayWidth end
if initHeight>displayHeight then initHeight=displayHeight end
if initLeft>(Turbine.UI.Display.GetWidth()-initWidth) then initLeft=Turbine.UI.Display.GetWidth()-initWidth end;
if initLeft<0 then initLeft=0 end;
if initWidth>(Turbine.UI.Display.GetWidth()-initLeft) then initWidth=Turbine.UI.Display.GetWidth()-initLeft end;
if initTop>(Turbine.UI.Display.GetHeight()-initHeight) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
if initTop<0 then initTop=0 end;
if initHeight>(Turbine.UI.Display.GetHeight()-initTop) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;

mainWindow = Turbine.UI.Lotro.Window();
mainWindow.MoveX=-1;
mainWindow.MoveY=-1;
mainWindow:SetSize(initWidth,initHeight);
mainWindow:SetPosition( initLeft, initTop );
mainWindow:SetVisible(false);
mainWindow:SetOpacity(Settings.Opacity);

mainWindow:SetText(Resource[language][2]);

mainWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		mainWindow:SetVisible(false);
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			mainWindow:SetVisible(mainVisible);
		else
			mainVisible=mainWindow:IsVisible();
			mainWindow:SetVisible(false);
		end
	end
end

mainWindow.MouseDown=function(sender,args)
	if mainWindow.PopUp~=nil then
		mainWindow.PopUpTop=mapWindow.PopUp:GetTop();
		mainWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
		mainWindow.PopUp:SetVisible(false);
		mainWindow.PopUp=nil; -- dismiss the dialog
	end
end

mainWindow.MouseMove=function(sender,args)
end

mainWindow.MouseUp=function(sender,args)
end

mainWindow.MouseClick=function(sender,args)
	if args.Button==2 then
		-- user right clicked on main window
	else
		-- user left clicked on main window
	end
end

mainWindow:SetWantsKeyEvents(true);
mainWindow:SetWantsUpdates(true)

mainWindow.RemoveShellCommands=function(sender,args)
	Turbine.Shell.RemoveCommand(mainWindow.shellCmd)
end

mainWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand(pluginName,mainWindow.shellCmd);

mainWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == string.lower(pluginName)) then
		local pos1=string.find(args," ",0,true);
		local command;
		if pos1~=nil and pos1>0 then
			command=string.lower(string.sub(args,1,pos1-1));
		else
			command=string.lower(args);
		end
		if (command=="show") then
			mainWindow:SetVisible(true);
		elseif (command=="hide") then
			mainWindow:SetVisible(false);
		elseif (command=="options") then
			OptionsWindow:SetVisible(true);
		elseif (command=="debug") then
			debugWindow:SetVisible(true);
		elseif (command=="toggle") then
			mainWindow:SetVisible(not mainWindow:IsVisible());
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /"..pluginName.." show");
			Turbine.Shell.WriteLine("       Displays "..pluginName..".");
			Turbine.Shell.WriteLine("  /"..pluginName.." hide");
			Turbine.Shell.WriteLine("       Hides "..pluginName..".");
			Turbine.Shell.WriteLine("  /"..pluginName.." toggle");
			Turbine.Shell.WriteLine("       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).");
			Turbine.Shell.WriteLine("  /"..pluginName.." options");
			Turbine.Shell.WriteLine("       Displays "..pluginName.." Options window.");
		end
	end
end
mainWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /"..pluginName.." show\n       Displays "..pluginName..".\n  /"..pluginName.." hide\n       Hides "..pluginName..".\n  /"..pluginName.." toggle\n       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).\n  /"..pluginName.." options\n       Displays "..pluginName.." Options window");
end
mainWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return(pluginName.." - usage: /"..pluginName.." show | hide | toggle");
end
mainWindow.SetTrimColor=function()
end
mainWindow.SetBackColor=function()
end
mainWindow.SetListTextColor=function()
end
mainWindow.SetFontColor=function()
end
mainWindow.SetHeadingsColor=function()
end
mainWindow.SetLanguage=function()
	mainWindow:SetText(Resource[language][2]);
end

function UnloadPlugin()
	SaveData();

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mainWindow:RemoveShellCommands();
--	mainWindow.MouseClick=nil;
end

function SaveData()
	-- save resolution so we can compare next time we are loaded
	Settings.DisplayWidth=displayWidth
	Settings.DisplayHeight=displayHeight
	-- save percents incase resolution changes
	Settings.MainTopPercent=mainWindow:GetTop()/displayHeight
	Settings.MainLeftPercent=mainWindow:GetLeft()/displayWidth
	Settings.MainWidthPercent=mainWindow:GetWidth()/displayWidth
	Settings.MainHeightPercent=mainWindow:GetHeight()/displayHeight
	-- save window size/position for if resolution does NOT change
	Settings.MainTop=mainWindow:GetTop()
	Settings.MainLeft=mainWindow:GetLeft()
	Settings.MainWidth=mainWindow:GetWidth()
	Settings.MainHeight=mainWindow:GetHeight()

	PatchDataSave( Turbine.DataScope.Character, pluginName.."Settings", Settings);
end

function mainWindow:Update( sender, args )
	if (Plugins[pluginName] ~= nil) and (not mainWindow.Loaded) then
		if not mainWindow.Refreshing then
			Turbine.Shell.WriteLine(pluginName.." "..Plugins[pluginName]:GetVersion()..Resource[language][3]);
		end
		Plugins[pluginName].Unload = function(mainWindow,sender,args)
			UnloadPlugin();
		end
		mainWindow:SetWantsUpdates(false);
	end
end

if Settings.DataVersion~=Plugins[pluginName]:GetVersion() then
	-- perform version change auto update stuff
	-- incorporate ALL data changes by DataVersion - this will guarantee all users can auto-update to latest version no matter what prior version they had and what versions they skipped
	--[[example
		if Settings.DataVersion==0.1 then
			-- do update .1->.2 stuff
			Settings.DataVersion=0.2
		end
		if Settings.DataVersion--0.3 then
			-- do update .2 -> .3 stuff
			Settings.DataVersion=0.3
		end
		-- etc. until we perform update to latest version and set data version to newset version
	]]--
end

mainWindow:SetVisible(true);

--optWindow=OptionsWindow();

--optWindow:SetZOrder(mapWindow:GetZOrder()+1);
debugWindow:SetZOrder(mainWindow:GetZOrder());
mainWindow:SetResizable(true)
mainWindow.TodayCaption=Turbine.UI.Label()
mainWindow.TodayCaption:SetParent(mainWindow)
mainWindow.TodayCaption:SetPosition(10,45)
mainWindow.TodayCaption:SetText(Resource[language][22]..":")

mainWindow.TodayVariant=Turbine.UI.Label()
mainWindow.TodayVariant:SetParent(mainWindow)
mainWindow.TodayVariant:SetTop(mainWindow.TodayCaption:GetTop())
mainWindow.TodayVariant:SetText(todayVariant)
mainWindow.TodayVariant:SetMultiline(false)
--***
mainWindow.RefreshTodayVariant=Turbine.UI.Button()
mainWindow.RefreshTodayVariant:SetParent(mainWindow)
mainWindow.RefreshTodayVariant:SetSize(16,16)
mainWindow.RefreshTodayVariant:SetBlendMode(Turbine.UI.BlendMode.Overlay)
mainWindow.RefreshTodayVariant:SetBackground(0x4111b60f)
--0x4111b60d - grey
--0x4111b60e - highlight
--0x4111b60f - normal
mainWindow.RefreshTodayVariant.Click=function()
	_,todayVariant=math.modf(math.floor((Turbine.Engine:GetLocalTime()-baseMaliceDate)/86400)/6)
	todayVariant=math.floor(todayVariant*6+.5)+1
	mainWindow.TodayVariant:SetText(todayVariant)
	mainWindow.RefreshTodayVariant:SetBackground(0x4111b60f) -- just in case
end
mainWindow.RefreshTodayVariant.MouseDown=function()
	mainWindow.RefreshTodayVariant:SetBackground(0x4111b60e)
end
mainWindow.RefreshTodayVariant.MouseLeave=function()
	mainWindow.RefreshTodayVariant:SetBackground(0x4111b60f)
end
mainWindow.RefreshTodayVariant.MouseUp=function()
	mainWindow.RefreshTodayVariant:SetBackground(0x4111b60f)
end

-- the main component, the "Malice List"
-- header row is Tier, Name, Description, Effect Name, Effect Description, Removal, Effect Duration
-- row height is determined by max of Description and Effect Description since they have a lot of text as well as multiple effects
mainWindow.MaliceBack=Turbine.UI.Control()
mainWindow.MaliceBack:SetParent(mainWindow)
mainWindow.MaliceBack:SetBackColor(Settings.TrimColor)
mainWindow.MaliceBack:SetLeft(10)
mainWindow.MaliceList=Turbine.UI.ListBox()
mainWindow.MaliceList:SetParent(mainWindow.MaliceBack)
mainWindow.MaliceList:SetPosition(1,1)
mainWindow.MaliceVScroll=Turbine.UI.Lotro.ScrollBar()
mainWindow.MaliceVScroll:SetParent(mainWindow)
mainWindow.MaliceVScroll:SetWidth(10)
mainWindow.MaliceVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
mainWindow.MaliceList:SetVerticalScrollBar(mainWindow.MaliceVScroll)
do
	local maliceHeading=Turbine.UI.Control()
	maliceHeading:SetParent(mainWindow.MaliceList)
	maliceHeading.Tier=Turbine.UI.Label()
	maliceHeading.Tier:SetParent(maliceHeading)
	maliceHeading.Tier:SetText(Resource[language][24])
	maliceHeading.Tier:SetBackColor(Settings.BackColor)

	maliceHeading.Name=Turbine.UI.Label()
	maliceHeading.Name:SetParent(maliceHeading)
	maliceHeading.Name:SetText(Resource[language][25])
	maliceHeading.Name:SetBackColor(Settings.BackColor)

	maliceHeading.Description=Turbine.UI.Label()
	maliceHeading.Description:SetParent(maliceHeading)
	maliceHeading.Description:SetText(Resource[language][26])
	maliceHeading.Description:SetBackColor(Settings.BackColor)

	maliceHeading.Effect=Turbine.UI.Label()
	maliceHeading.Effect:SetParent(maliceHeading)
	maliceHeading.Effect:SetText(Resource[language][27])
	maliceHeading.Effect:SetBackColor(Settings.BackColor)

	maliceHeading.EffectDesc=Turbine.UI.Label()
	maliceHeading.EffectDesc:SetParent(maliceHeading)
	maliceHeading.EffectDesc:SetText(Resource[language][28])
	maliceHeading.EffectDesc:SetBackColor(Settings.BackColor)
	maliceHeading.EffectDesc.rgbText=Resource[language][28]

	maliceHeading.Removal=Turbine.UI.Label()
	maliceHeading.Removal:SetParent(maliceHeading)
	maliceHeading.Removal:SetText(Resource[language][29])
	maliceHeading.Removal:SetBackColor(Settings.BackColor)

	maliceHeading.Duration=Turbine.UI.Label()
	maliceHeading.Duration:SetParent(maliceHeading)
	maliceHeading.Duration:SetText(Resource[language][30])
	maliceHeading.Duration:SetBackColor(Settings.BackColor)

	mainWindow.MaliceList:AddItem(maliceHeading)
end
function fillList(variant)
	for k=1,12 do
		local tmpRow=Turbine.UI.Control()
		tmpRow:SetParent(mainWindow.MaliceList)
		tmpRow.Tier=Turbine.UI.Label()
		tmpRow.Tier:SetParent(tmpRow)
		tmpRow.Tier:SetText(k)
		tmpRow.Tier:SetBackColor(Settings.BackColor)

		tmpRow.Name=Turbine.UI.Label()
		tmpRow.Name:SetParent(tmpRow)
		tmpRow.Name:SetText(EpicVariant[variant][k][1])
		tmpRow.Name:SetBackColor(Settings.BackColor)

		tmpRow.Description=Turbine.UI.Label()
		tmpRow.Description:SetParent(tmpRow)
		tmpRow.Description:SetText(EpicVariant[variant][k][2])
		tmpRow.Description:SetBackColor(Settings.BackColor)

		tmpRow.Effect=Turbine.UI.Label()
		tmpRow.Effect:SetParent(tmpRow)
		local tmpEffect=EpicVariant[variant][k][3]
		if tmpEffect~=nil then
			if EpicEffect[tmpEffect]~=nil then
				tmpRow.Effect:SetText(EpicEffect[tmpEffect][1])
			else
				tmpRow.Effect:SetText("")
			end
		else
			tmpRow.Effect:SetText("")
		end
		tmpRow.Effect:SetBackColor(Settings.BackColor)

		tmpRow.EffectDesc=Turbine.UI.Label()
		tmpRow.EffectDesc:SetParent(tmpRow)
		tmpRow.EffectDesc:SetMarkupEnabled(true)
		local tmpDesc=""
		if tmpEffect~=nil then
			if EpicEffect[tmpEffect]~=nil then
				if EpicEffect[tmpEffect][2]~=nil then
					tmpDesc=EpicEffect[tmpEffect][2]
				end
				if EpicEffect[tmpEffect][5]~=nil and type(EpicEffect[tmpEffect][5])=="table" then
					for k,v in ipairs(EpicEffect[tmpEffect][5]) do
						tmpDesc=tmpDesc..'\n<rgb=#c80000>'..tostring(v).."</rgb>"
					end
				end
			end
		end
		tmpRow.EffectDesc.rgbText=tmpDesc
		tmpRow.EffectDesc:SetText(tmpDesc)
		tmpRow.EffectDesc:SetBackColor(Settings.BackColor)

		tmpRow.Removal=Turbine.UI.Label()
		tmpRow.Removal:SetParent(tmpRow)
		if tmpEffect~=nil then
			if EpicEffect[tmpEffect]~=nil and EpicEffect[tmpEffect][3]~=nil then
				tmpRow.Removal:SetText(EpicEffect[tmpEffect][3])
			else
				tmpRow.Removal:SetText("")
			end
		else
			tmpRow.Removal:SetText("")
		end
		tmpRow.Removal:SetBackColor(Settings.BackColor)

		tmpRow.Duration=Turbine.UI.Label()
		tmpRow.Duration:SetParent(tmpRow)
		if tmpEffect~=nil then
			if EpicEffect[tmpEffect]~=nil and EpicEffect[tmpEffect][4]~=nil then
				tmpRow.Duration:SetText(EpicEffect[tmpEffect][4])
			else
				tmpRow.Duration:SetText("")
			end
		else
			tmpRow.Duration:SetText("")
		end
		tmpRow.Duration:SetBackColor(Settings.BackColor)

		mainWindow.MaliceList:AddItem(tmpRow)
	end
end
fillList(todayVariant)

mainWindow.FontSelect=FontSelect()
mainWindow.FontSelect:SetParent(mainWindow)
mainWindow.FontSelect:SetFont(Settings.Font)
--mainWindow.FontSelect:SetBackColor(Turbine.UI.Color.Red)
mainWindow.FontSelect.FontChanged=function()
	-- use changed font
	local newFont=mainWindow.FontSelect:GetFont()
	Settings.Font=newFont
	local fontHeight=Turbine.UI.Lotro.FontInfo[newFont].size
	fontMetric:SetFont(newFont)

	mainWindow.TodayCaption:SetFont(newFont)
	mainWindow.TodayCaption:SetWidth(fontMetric:GetTextWidth(mainWindow.TodayCaption:GetText()))
	mainWindow.TodayCaption:SetHeight(fontHeight)
	mainWindow.TodayCaption:SetText(mainWindow.TodayCaption:GetText())

	mainWindow.TodayVariant:SetFont(newFont)
	mainWindow.TodayVariant:SetWidth(fontMetric:GetTextWidth("8"))
	mainWindow.TodayVariant:SetHeight(fontHeight)
	mainWindow.TodayVariant:SetText(todayVariant)

-- handle table - FONT ISSUES ONLY - size/pos are handled in layout
	for k=1, mainWindow.MaliceList:GetItemCount() do
		local tmpRow=mainWindow.MaliceList:GetItem(k)
		tmpRow.Tier:SetFont(newFont)
		tmpRow.Tier:SetText(tmpRow.Tier:GetText())
		tmpRow.Name:SetFont(newFont)
		tmpRow.Name:SetText(tmpRow.Name:GetText())
		tmpRow.Description:SetFont(newFont)
		tmpRow.Description:SetText(tmpRow.Description:GetText())
		tmpRow.Effect:SetFont(newFont)
		tmpRow.Effect:SetText(tmpRow.Effect:GetText())
		tmpRow.EffectDesc:SetFont(newFont)
		tmpRow.EffectDesc:SetText(tmpRow.EffectDesc.rgbText)
		tmpRow.Removal:SetFont(newFont)
		tmpRow.Removal:SetText(tmpRow.Removal:GetText())
		tmpRow.Duration:SetFont(newFont)
		tmpRow.Duration:SetText(tmpRow.Duration:GetText())

	end

	--now call layout to reposition all these resized controls
	mainWindow:Layout()
end
mainWindow.Layout=function()
	-- layout controls
	mainWindow.TodayVariant:SetLeft(mainWindow.TodayCaption:GetLeft()+mainWindow.TodayCaption:GetWidth()+10)
	mainWindow.RefreshTodayVariant:SetLeft(mainWindow.TodayVariant:GetLeft()+mainWindow.TodayVariant:GetWidth()+15)
	mainWindow.RefreshTodayVariant:SetTop(mainWindow.TodayVariant:GetTop()+mainWindow.TodayVariant:GetHeight()/2-8) -- align middle of variant

	-- determine bottom contol layout
	mainWindow.FontSelect:SetPosition(mainWindow:GetWidth()-65,mainWindow:GetHeight()-30)

	-- determine list layout (all remaining space)
	mainWindow.MaliceBack:SetWidth(mainWindow:GetWidth()-30)
	mainWindow.MaliceBack:SetTop(mainWindow.TodayVariant:GetTop()+mainWindow.TodayVariant:GetHeight()+10)
	mainWindow.MaliceBack:SetHeight(mainWindow.FontSelect:GetTop()-10-mainWindow.MaliceBack:GetTop())
	local rowWidth=mainWindow:GetWidth()-32
	mainWindow.MaliceList:SetWidth(rowWidth)
	mainWindow.MaliceList:SetHeight(mainWindow.MaliceBack:GetHeight()-2)
	mainWindow.MaliceVScroll:SetPosition(mainWindow.MaliceBack:GetLeft()+mainWindow.MaliceBack:GetWidth(),mainWindow.MaliceBack:GetTop())
	mainWindow.MaliceVScroll:SetHeight(mainWindow.MaliceBack:GetHeight())
	-- handle table layout
	local headerRow=mainWindow.MaliceList:GetItem(1)
	local tierWidth=fontMetric:GetTextWidth(headerRow.Tier:GetText()..".")
	local nameWidth=fontMetric:GetTextWidth(headerRow.Name:GetText()..".")
	local effectWidth=fontMetric:GetTextWidth(headerRow.Effect:GetText()..".")
	local removalWidth=fontMetric:GetTextWidth(headerRow.Removal:GetText()..".")
	local durationWidth=fontMetric:GetTextWidth(headerRow.Duration:GetText()..".")
	for k=2,mainWindow.MaliceList:GetItemCount() do
		-- need to adjust nameWidth, effectWidth and removalWidth based on width of actual text as Text may be wider than Caption
		local tmpRow=mainWindow.MaliceList:GetItem(k)
		local tmpWidth=fontMetric:GetTextWidth(tmpRow.Name:GetText())
		if tmpWidth>nameWidth then nameWidth=tmpWidth end
		tmpWidth=fontMetric:GetTextWidth(tmpRow.Effect:GetText())
		if tmpWidth>effectWidth then effectWidth=tmpWidth end
		tmpWidth=fontMetric:GetTextWidth(tmpRow.Removal:GetText())
		if tmpWidth>removalWidth then removalWidth=tmpWidth end
	end
	-- split remainder between descriptions
	local descriptionWidth=(rowWidth-tierWidth-nameWidth-effectWidth-removalWidth-durationWidth-6)/2
	local effectDescWidth=descriptionWidth

	local even=true
	local bgColor
	for k=1,mainWindow.MaliceList:GetItemCount() do
		local tmpRow=mainWindow.MaliceList:GetItem(k)
		bgColor=Turbine.UI.Color(.1,.1,.2)
		if k>1 then
			if even then
				bgColor=Turbine.UI.Color(.1,.1,.1)
			else
				bgColor=Turbine.UI.Color(.05,.05,.1)
			end
		end
		tmpRow:SetWidth(rowWidth)
		tmpRow.Tier:SetWidth(tierWidth)
		tmpRow.Tier:SetBackColor(bgColor)
		tmpRow.Name:SetLeft(tierWidth+1)
		tmpRow.Name:SetWidth(nameWidth)
		tmpRow.Name:SetBackColor(bgColor)
		tmpRow.Description:SetLeft(tmpRow.Name:GetLeft()+nameWidth+1)
		tmpRow.Description:SetWidth(descriptionWidth)
		tmpRow.Description:SetBackColor(bgColor)
		tmpRow.Effect:SetWidth(effectWidth)
		tmpRow.Effect:SetLeft(tmpRow.Description:GetLeft()+descriptionWidth+1)
		tmpRow.Effect:SetBackColor(bgColor)
		tmpRow.EffectDesc:SetWidth(effectDescWidth)
		tmpRow.EffectDesc:SetLeft(tmpRow.Effect:GetLeft()+effectWidth+1)
		tmpRow.EffectDesc:SetBackColor(bgColor)
		tmpRow.Removal:SetWidth(removalWidth)
		tmpRow.Removal:SetLeft(tmpRow.EffectDesc:GetLeft()+effectDescWidth+1)
		tmpRow.Removal:SetBackColor(bgColor)
		tmpRow.Duration:SetWidth(durationWidth)
		tmpRow.Duration:SetLeft(tmpRow.Removal:GetLeft()+removalWidth+1)
		tmpRow.Duration:SetBackColor(bgColor)
		-- determine height from max(description, effectDesc) height
		local rowHeight=fontMetric:GetTextHeight(tmpRow.Description:GetText(),descriptionWidth)
		local effectDescHeight=fontMetric:GetTextHeight(tmpRow.EffectDesc:GetText(),effectDescWidth)
		if effectDescHeight>rowHeight then rowHeight=effectDescHeight end
		tmpRow:SetHeight(rowHeight+1)
		tmpRow.Tier:SetHeight(rowHeight)
		tmpRow.Name:SetHeight(rowHeight)
		tmpRow.Description:SetHeight(rowHeight)
		tmpRow.Effect:SetHeight(rowHeight)
		tmpRow.EffectDesc:SetHeight(rowHeight)
		tmpRow.Removal:SetHeight(rowHeight)
		tmpRow.Duration:SetHeight(rowHeight)
		even=not even
	end
end
mainWindow.SizeChanged=function()
	local width,height=mainWindow:GetSize()
	if width<100 then
		width=MinWidth
		mainWindow:SetWidth(width)
	end
	if height<30 then
		height=MinHeight
		mainWindow:SetHeight(height)
	end
	mainWindow:Layout()
end
mainWindow.FontSelect.FontChanged() -- assign the current font and call layout

-- main window should show the current malice Variant by default with Variant being in a dropdown so that other Variants can be shown , epic malice version across top
-- tiers 1-12 should be down the side with malice name / description / effect shown
